/************************************************

       This file has no copyright assigned
          and is in the Public Domain.

		 http://home.scarlet.be/zoetrope
         http://home.tiscali.be/zoetrope

************************************************/
#include <string.h>

static void swap(unsigned char *i, unsigned char *j)
{
	unsigned char t;

	t = *i;
	*i = *j;
	*j = t;
}

void arcfour(char *dest, const char *src, const char *key)
{
	unsigned char S[256], k;
	unsigned i, j, keylength;
	char *p, *q;

	keylength = (unsigned)strlen(key);
	for (i = 0; i < 256; i++)
		S[i] = (unsigned char)i;
	j = 0;
	for (i = 0; i < 256; i++) {
		j = (j + S[i] + key[i % keylength]) % 256;
		swap(&S[i], &S[j]);
	}

	i = 0;
	j = 0;
	p = (char *)src;
	q = (char *)dest;
	while (*p) {
		i = (i + 1) % 256;
		j = (j + S[i]) % 256;
		swap(&S[i], &S[j]);
		k = S[(S[i] + S[j]) % 256];
		*q++ = *p++ ^ k;
	}
}


